﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class KryptoniteBehaviour : MonoBehaviour
    {
        public float CheckMult = 1f;
        public Color Color = new Color(0.6f, 0.8f, 0.6f, 1f);
        public bool gay = false;
        private bool gayyed;
        public bool Good;

        public void FixedUpdate()
        {
            if (this.gay)
            {
                return;
            }
            if (this.Good)
            {
                Collider2D[] Cols2 = new Collider2D[50];
                int cast2 = Physics2D.OverlapCircleNonAlloc(this.transform.position, 1.5f * CheckMult, Cols2);
                for (var i = 0; i < cast2; i++)
                {
                    var col = Cols2[i];
                    if (col.gameObject.GetComponent<LimbBehaviour>() != null && col.gameObject.GetComponent<KyrptonGuy>() == null)
                    {
                        foreach (var Limb in col.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                        {
                            Limb.BreakingThreshold *= 10f;
                            Limb.ImmuneToDamage = true;
                            Limb.ImpactPainMultiplier = 0f;
                            Limb.ShotDamageMultiplier = 0f;
                            Limb.Vitality *= 100f;
                            Limb.Health *= 100f;
                            Limb.InitialHealth *= 100f;
                            Limb.IsLethalToBreak = false;
                            Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                            Limb.PhysicalBehaviour.ConductOverride = true;
                            Limb.PhysicalBehaviour.EnergyWireResistance *= 100f;
                            Limb.PhysicalBehaviour.ForceNoCharge = true;
                            Limb.PhysicalBehaviour.SimulateTemperature = false;
                            Limb.PhysicalBehaviour.ReflectsLasers = true;
                            Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                            Limb.CirculationBehaviour.ImmuneToDamage = true;
                            Limb.SkinMaterialHandler.intensityMultiplier = 0f;
                            Limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
                            Limb.gameObject.AddComponent<KyrptonGuy>();
                        }
                    }
                }
                return;
            }
            Collider2D[] Cols = new Collider2D[50];
            int cast = Physics2D.OverlapCircleNonAlloc(this.transform.position, 1.5f * CheckMult, Cols);
            for (var i = 0; i < cast; i++)
            {
                var col = Cols[i];
                if (col.gameObject.GetComponent<LimbBehaviour>() != null && col.gameObject.GetComponent<KyrptonGuy>() != null && !col.gameObject.GetComponent<KyrptonGuy>().On)
                {
                    foreach (var limb in col.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                    {
                        col.gameObject.GetComponent<KyrptonGuy>().On = true;
                        limb.StartCoroutine(ColorLerpUp(limb.PhysicalBehaviour.spriteRenderer, this.Color));
                        limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Human");
                        limb.ShotDamageMultiplier = 1f;
                        limb.ImpactPainMultiplier = 1f;
                        limb.ImmuneToDamage = false;
                        limb.CirculationBehaviour.ImmuneToDamage = false;
                        if (CheckMult >= 2.5f)
                        {
                            limb.BloodMuscleStrengthRatio -= 3f;
                            limb.BaseStrength -= 3f;
                            limb.Damage(3f);
                            limb.SkinMaterialHandler.ImpactDamage(5f, limb.transform.position);
                        }
                        col.GetComponent<LimbBehaviour>().Person.Consciousness = 0.85f;
                        col.GetComponent<LimbBehaviour>().StartCoroutine(Delay(col.GetComponent<LimbBehaviour>()));
                    }
                }
            }
        }

        public void OnCollisionEnter2D(Collision2D col)
        {
            if (this.gay && col.gameObject.GetComponent<KyrptonGuy>() != null && col.transform.root.gameObject.name.Contains("Superman") && !this.gayyed)
            {
                ModAPI.Notify("<b>Superman:</b> I am romantically interested in men now.");
                this.gayyed = true;
            }
        }

        private IEnumerator Delay(LimbBehaviour limb)
        {
            yield return new WaitForSeconds(25f);
            limb.StartCoroutine(ColorLerpDown(limb.PhysicalBehaviour.spriteRenderer, new Color(1f, 1f, 1f, 1f)));
            limb.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Incredible");
            limb.ShotDamageMultiplier = 0f;
            limb.ImpactPainMultiplier = 0f;
            limb.ImmuneToDamage = true;
            limb.CirculationBehaviour.ImmuneToDamage = true;
            limb.gameObject.GetComponent<KyrptonGuy>().On = false;
            yield return new WaitForEndOfFrame();
        }

        private IEnumerator ColorLerpUp(SpriteRenderer Start, Color End)
        {
            while (Start.color.b > End.b + 0.05f)
            {
                Start.color = Color.Lerp(Start.color, End, Time.deltaTime / 6f); //Lerp slows down at the end
                yield return new WaitForEndOfFrame();
            }
            Start.color = End;
        }

        private IEnumerator ColorLerpDown(SpriteRenderer Start, Color End)
        {
            while (Start.color.b < End.b - 0.05f)
            {
                Start.color = Color.Lerp(Start.color, End, Time.deltaTime / 6f); //Lerp slows down at the end
                yield return new WaitForEndOfFrame();
            }
            Start.color = Color.white;
        }
    }

    public class KyrptonGuy : MonoBehaviour
    {
        public bool On;

        private void Start()
        {
            this.gameObject.GetComponent<CirculationBehaviour>().AddLiquid(Liquid.GetLiquid("WATER BREATHING SERUM"), 0.25f);
        }
    }

    public class GreenBowBehaviour : MonoBehaviour
    {
        public enum Modes
        {
            Normal,
            Electric,
            Explosive,
            KryptoniteTipped
        };

        public Modes Mode = Modes.Normal;

        private void Awake()
        {
            foreach (Modes themode in Enum.GetValues(typeof(Modes)))
            {
                this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("Change Mode: " + themode.ToString(), delegate ()
                {
                    return "Change Mode: " + themode.ToString();
                }, "Change Mode: " + themode.ToString(), new UnityAction[]
                {
                    delegate()
                    {
                        this.Mode = themode;
                    }
                }));
            }
            this.gameObject.GetComponent<ProjectileLauncherBehaviour>().OnLaunch += Launched;
        }

        private void Launched(object sender, GameObject proj)
        {
            switch (this.Mode)
            {
                case Modes.Electric:
                    proj.AddComponent<Electric>();
                    break;

                case Modes.Explosive:
                    proj.AddComponent<Explosive>();
                    break;

                case Modes.KryptoniteTipped:
                    proj.AddComponent<KryptoniteBehaviour>().CheckMult = 2f;
                    break;

                default:
                    break;
            }
        }

        private class Electric : MonoBehaviour, Messages.ILodged
        {
            public void Lodged(Stabbing stab)
            {
                this.gameObject.GetComponent<PhysicalBehaviour>().charge += 25f;
            }
        }

        private class Explosive : MonoBehaviour
        {
            public void Lodged(Stabbing stab)
            {
                ExplosionCreator.CreateFragmentationExplosion(50U, this.transform.position, 3f, 4f, transform);
                this.gameObject.SetActive(false);
            }
        }
    }
}
