﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    //An empty class for you to copy paste and fill with your own powers!
    public class AnimatedObject : MonoBehaviour
    {
        public List<Sprite> AnimationList = new List<Sprite>();
        public Coroutine AnimationCoroutine;
        public int FrameCount = 0;


        public void Update()
        {
        //    if (AnimationCoroutine == null)
         //       AnimationCoroutine = StartCoroutine(WingAnimations());
        }

        public void Start()
        {
            AnimationCoroutine = StartCoroutine(WingAnimations());
        }


        IEnumerator WingAnimations()
        {
            yield return new WaitForSeconds(0.015f);
            FrameCount = FrameCount += 1;
            if (FrameCount >= AnimationList.Count - 1)
                FrameCount = 0;
            GetComponent<SpriteRenderer>().sprite = AnimationList[FrameCount];
            AnimationCoroutine = StartCoroutine(WingAnimations());
        }
    }
}
