using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;

namespace DCPP
{
    public class anim : MonoBehaviour
    {
        private Material material;
        public SpriteRenderer renderer;
        public LimbBehaviour limb;
        public float t;
        public Texture2D OgSkin = null;
        public Texture2D OgBones = null;
        public Texture2D OgFlesh = null;
        public bool rev;

        public void Start()
        {
                        renderer = this.gameObject.GetComponent<SpriteRenderer>();
                        limb = this.gameObject.GetComponent<LimbBehaviour>();
                        if ((UnityEngine.Object) limb.Person.ChosenMaterial != (UnityEngine.Object) null)
                        renderer.material = limb.Person.ChosenMaterial;
                        material = renderer.material;
                        StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
            t = 1f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.95f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.9f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.85f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.8f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.75f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.7f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.65f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.6f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.55f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.5f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.45f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.4f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.35f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.3f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.25f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.2f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.15f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.15f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0.05f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            t = 0f;
            material.SetFloat(ShaderProperties.Get("_AcidProgress"), t);
            yield return new WaitForSeconds(0.05f);
            if (rev)
            {
                this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().SetBodyTextures(OgSkin, OgFlesh, OgBones);
            }
            Destroy(this.gameObject.GetComponent<anim>());
        }
    }
    public class BeetleSuit : PowerBase
    { 

       public int SporeAmount = 5;
       private Material material;
       public SpriteRenderer renderer;
       public LimbBehaviour limb;
       public bool Mode = false;
       public Texture2D OgSkin = null;
       public Texture2D OgBones = null;
       public Texture2D OgFlesh = null;
       public Texture2D Suit = ResourceStorage.Skin_BeetleSuit;
       public AudioClip Enable = ResourceStorage.Sound_BeetleEnable;
       public AudioClip Disable = ResourceStorage.Sound_BeetleDisable;
       public AudioClip Shoot = ResourceStorage.Sound_BeetleShoot;
       public AudioSource audioSource;

       private void Awake()
  {

    audioSource = new GameObject().gameObject.AddComponent<AudioSource>();
    audioSource.transform.SetParent(transform, false);
    GameObject.FindObjectOfType<Global>().AddAudioSource(audioSource,false);
    audioSource.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.75f;
    audioSource.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
    audioSource.spatialBlend = 1;
    audioSource.volume = 1;
  }
       
       public void Start()
       {
           OgSkin = this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.sprite.texture;
           OgFlesh = (Texture2D)this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_FleshTex");
           OgBones = (Texture2D)this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_BoneTex");

foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
               this.renderer = Limbs.gameObject.GetComponent<SpriteRenderer>();
    this.limb = Limbs;
    if ((UnityEngine.Object) Limbs.Person.ChosenMaterial != (UnityEngine.Object) null)
      this.renderer.material = Limbs.Person.ChosenMaterial;
    this.material = this.renderer.material;
       }
this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    if (Mode)
                    {
                        audioSource.PlayOneShot(Shoot);
                        GameObject qa = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.cyan;
                                    qa.GetComponent<BlasterboltBehaviour>().damage = 23f;
                                    qa.GetComponent<BlasterboltBehaviour>().Speed = 34f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.1f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.time = 0.07f;
                                    
                                    qa.transform.position = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position;
                                    qa.transform.eulerAngles = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.eulerAngles;
                                    qa.transform.eulerAngles += new Vector3(0, 0, 270);
                    }
                };
                this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    if (Mode)
                    {
                        audioSource.PlayOneShot(Shoot);
                        GameObject qa = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                qa.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.cyan;
                                    qa.GetComponent<BlasterboltBehaviour>().damage = 23f;
                                    qa.GetComponent<BlasterboltBehaviour>().Speed = 34f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.clear;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.1f;
                                    qa.GetComponent<BlasterboltBehaviour>().Trail.time = 0.07f;
                                    
                                    qa.transform.position = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
                                    qa.transform.eulerAngles = this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.eulerAngles;
                                    qa.transform.eulerAngles += new Vector3(0, 0, 270);
                    }
                };
       }

       public override void UsePower()
       {
           if (Mode)
           {
            Mode = false;
                        this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(OgSkin, Suit, Suit);
                        audioSource.PlayOneShot(Disable);
                        StartCoroutine(WaitToSwitch());
                        this.gameObject.GetComponent<CirculationBehaviour>().AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 3f);
                        foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           this.renderer = Limbs.gameObject.GetComponent<SpriteRenderer>();
    this.limb = Limbs;
    if ((UnityEngine.Object) Limbs.Person.ChosenMaterial != (UnityEngine.Object) null)
      this.renderer.material = Limbs.Person.ChosenMaterial;
    this.material = this.renderer.material;
           var properties = ModAPI.FindPhysicalProperties("Human");
                        Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
          Limbs.gameObject.AddComponent<anim>();
          Limbs.gameObject.GetComponent<anim>().rev = true;
         Limbs.gameObject.GetComponent<anim>().OgSkin = OgSkin;
          Limbs.gameObject.GetComponent<anim>().OgFlesh = OgFlesh;
          Limbs.gameObject.GetComponent<anim>().OgBones = OgBones;
    
       }
           }
           else
           {
            Mode = true;
                   this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(Suit, Suit, OgSkin);
                   audioSource.PlayOneShot(Enable);
                   StartCoroutine(WaitToSwitch());
                   this.gameObject.GetComponent<CirculationBehaviour>().AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 3f);
            foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           this.renderer = Limbs.gameObject.GetComponent<SpriteRenderer>();
    this.limb = Limbs;
    if ((UnityEngine.Object) Limbs.Person.ChosenMaterial != (UnityEngine.Object) null)
      this.renderer.material = Limbs.Person.ChosenMaterial;
    this.material = this.renderer.material;
           var properties = ModAPI.FindPhysicalProperties("AndroidArmour");
                        Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
          Limbs.gameObject.AddComponent<anim>();
                Limbs.BruiseCount = (ushort)0;
                Limbs.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                Limbs.CirculationBehaviour.StabWoundCount = (ushort)0;
        
       }
           }
       }

       public IEnumerator WaitToSwitch() //funny animation
 {
     for (int i = 0; i < SporeAmount; i++)
        {
            foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
            Limbs.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 3f);
                        yield return new WaitForSeconds(0.2f);
       }
        }
 }

 
       /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected Limbs of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, GameObject Instance)
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            // You can use GetOrAddComponent if you want here. - Aspa
            if (!body.GetComponent<BeetleSuit>())
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                body.gameObject.AddComponent<BeetleSuit>();
                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                body.GetComponent<BeetleSuit>().PowerIcon = ResourceStorage.Sprite_CyborgBlasterPowerIcon;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    body.gameObject.GetComponent<BeetleSuit>().UsePower();
                };
            }
        }
       }
    }