﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace DCPP
{
    public class RogVoice : MonoBehaviour
    {
        public AudioClip PantsFeetSong = ModAPI.LoadSound("Assets/People/Wilson/rogsong.wav");
        //   public AudioClip AvengersSong = ModAPI.LoadSound("Wilson Evolved.wav");
        public AudioClip Pain = ModAPI.LoadSound("Assets/People/Wilson/rogpain.wav");
        public AudioClip Dead = ModAPI.LoadSound("Assets/People/Wilson/RogKill.wav");
        public AudioClip sleepp = ModAPI.LoadSound("Assets/People/Wilson/rog sleep.wav");
        public AudioSource audio;
        List<GameObject> Hands = new List<GameObject>();
        bool SetDead = false;
        bool Sleep = false;
        bool Sword = false;
        public void Start()
        {
            GameObject AUdio = new GameObject();
            AUdio.transform.SetParent(transform, false);
            audio = AUdio.gameObject.AddComponent<AudioSource>();
            audio.spatialBlend = 1;
            AUdio.AddComponent<AudioDistortionFilter>().distortionLevel = 0.8f;
            item = GetComponent<LimbBehaviour>();
            foreach (var item in transform.parent.GetComponentsInChildren<GripBehaviour>())
            {
                Hands.Add(item.gameObject);
            }
        }

        public LimbBehaviour item;
        public void Update()
        {
            if (item.IsConsideredAlive && item.Person.Consciousness > 0.8f)
            {
                Sleep = false;
                SetDead = false;
                if (!(item.Person.ShockLevel > 0) && ((!Sword && audio.clip != PantsFeetSong)))
                {
                    if (!Sword)
                        audio.clip = PantsFeetSong;
                    //     else audio.clip = AvengersSong;
                    audio.loop = true;
                    audio.Play();
                }
                else
                {
                    if ((item.Person.ShockLevel > 0) && audio.clip != Pain)
                    {
                        audio.clip = Pain;
                        audio.loop = true;
                        audio.Play();
                    }
                }
            }
            else if (item.Person.Consciousness < 0.8f && !Sleep)
            {
                audio.Stop();
                Sleep = true;
                audio.clip = sleepp;
                audio.loop = false;
                audio.Play();
            }
            else if (!item.IsConsideredAlive && !SetDead)
            {
                SetDead = true;
                audio.clip = Dead;
                audio.loop = false;
                audio.Play();
            }


            //if ((Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword") || (Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword"))
            //    Sword = true;
            //else Sword = false;


        }


    }
}
